﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Text.RegularExpressions;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace Hexadecimal
{
    public partial class Form1 : Form
    {
        private HexHelper hexHelper = new HexHelper();
        public Form1()
        {
            InitializeComponent();
            this.Text += " V" + System.Reflection.Assembly.GetExecutingAssembly().GetName().Version.ToString();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            txt1_16.Text = hexHelper.GetLTStr(txt1_ascii.Text);
        }

        private void button2_Click(object sender, EventArgs e)
        {
            txt2_ascii.Text = hexHelper.GetDecLTStr(txt2_16.Text);
        }

        private void button3_Click(object sender, EventArgs e)
        {
            try
            {
                txt_cy_16.Text = HexStringToString(txt_cy_ascii.Text).ToUpper();
            }
            catch
            {
            }
        }
        private void button4_Click(object sender, EventArgs e)
        {
            try
            {
                txt_cy1_ascii.Text = HexStringToASCII(txt_cy1_16.Text);
            }
            catch
            {
            }
        }
        /// <summary>
        /// 将ASCII码转换为16进制
        /// </summary>
        /// <param name="hs"></param>
        /// <returns></returns>
        private string HexStringToString(string hs)
        {
            byte[] b = Encoding.Default.GetBytes(hs);//按照指定编码将string编程字节数组
            string result = string.Empty;
            for (int i = 0; i < b.Length; i++)//逐字节变为16进制字符
            {
                result += Convert.ToString(b[i], 16);
            }
            return result;
        }
        /// <summary>
        /// 将一条十六进制字符串转换为ASCII
        /// </summary>
        /// <param name="hexstring">一条十六进制字符串</param>
        /// <returns>返回一条ASCII码</returns>
        public static string HexStringToASCII(string hexstring)
        {
            string result = Regex.Replace(hexstring, @".{2}", "$0 ");
            byte[] bt = HexStringToBinary(result);
            string lin = "";
            for (int i = 0; i < bt.Length; i++)
            {
                lin = lin + bt[i] + " ";
            }


            string[] ss = lin.Trim().Split(new char[] { ' ' });
            char[] c = new char[ss.Length];
            int a;
            for (int i = 0; i < c.Length; i++)
            {
                a = Convert.ToInt32(ss[i]);
                c[i] = Convert.ToChar(a);
            }

            string b = new string(c);
            return b;
        }
        /// <summary>
        /// 16进制字符串转换为二进制数组
        /// </summary>
        /// <param name="hexstring">用空格切割字符串</param>
        /// <returns>返回一个二进制字符串</returns>
        public static byte[] HexStringToBinary(string hexstring)
        {
            string[] tmpary = hexstring.Trim().Split(' ');
            byte[] buff = new byte[tmpary.Length];
            for (int i = 0; i < buff.Length; i++)
            {
                buff[i] = Convert.ToByte(tmpary[i], 16);
            }
            return buff;
        }

        private void Form1_Load(object sender, EventArgs e)
        {

        }

        private void button6_Click(object sender, EventArgs e)
        {
            txt_zw16.Text = HexHelper.GetHexFromChs(txt_zw.Text);
        }

        private void button5_Click(object sender, EventArgs e)
        {
            txt_zw1.Text = HexHelper.GetChsFromHex(txt_zw161.Text);
        }

        private void txt_cy_ascii_TextChanged(object sender, EventArgs e)
        {
            txt_cy_asciiLen.Text = "字符长度：" + txt_cy_ascii.Text.Length.ToString() + "/HEX：" + (txt_cy_ascii.Text.Length / 2);
        }

        private void txt_cy_16_TextChanged(object sender, EventArgs e)
        {
            txt_cy_16Len.Text = "字符长度：" + txt_cy_16.Text.Length.ToString() + "/HEX：" + (txt_cy_16.Text.Length / 2);
        }

        private void txt_cy1_16_TextChanged(object sender, EventArgs e)
        {
            txt_cy1_16Len.Text = "字符长度：" + txt_cy1_16.Text.Length.ToString() + "/HEX：" + (txt_cy1_16.Text.Length / 2);
        }

        private void txt_cy1_ascii_TextChanged(object sender, EventArgs e)
        {
            txt_cy1_asciiLen.Text = "字符长度：" + txt_cy1_ascii.Text.Length.ToString() + "/HEX：" + (txt_cy1_ascii.Text.Length / 2);
        }

        private void txt_Dev16_TextChanged(object sender, EventArgs e)
        {
            lbl_DevLen.Text = "字符长度：" + txt_Dev16.Text.Length.ToString() + "/HEX：" + (txt_Dev16.Text.Length / 2);
        }
    }
}
