﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Hexadecimal
{
    /// <summary>
    /// 进制转换帮助类
    /// </summary>
    public class HexHelper
    {
        #region 加码制
        /// <summary>
        /// 返回转换的进制
        /// </summary>
        /// <param name="val"></param>
        /// <returns></returns>
        public string GetLTStr(string val)
        {
            string str = "";
            string v = "";
            for (int i = 0; i < val.Length; i++)
            {
                char c = val[i];
                v += HexBinary(c.ToString());
            }
            for (int i = 0; i < v.Length; i++)
            {
                if (i % 4 == 0)
                {
                    string c = v.Substring(i, 4);
                    str += GetHexadecimal(c);
                }
            }
            return str;
        }
        /// <summary>
        /// 2进制转换16进制
        /// </summary>
        /// <param name="str">4位的2进制</param>
        /// <returns></returns>
        private string GetHexadecimal(string str)
        {
            return string.Format("{0:X}", System.Convert.ToInt32(str, 2));
        }
        /// <summary>
        /// 转换成2进制
        /// </summary>
        /// <param name="str">单个字母</param>
        /// <returns></returns>
        private string HexBinary(string str)
        {
            string v = "";
            switch (str)
            {
                case "0":
                    v = "010000";
                    break;
                case "1":
                    v = "010001";
                    break;
                case "2":
                    v = "010010";
                    break;
                case "3":
                    v = "010011";
                    break;
                case "4":
                    v = "010100";
                    break;
                case "5":
                    v = "010101";
                    break;
                case "6":
                    v = "010110";
                    break;
                case "7":
                    v = "010111";
                    break;
                case "8":
                    v = "011000";
                    break;
                case "9":
                    v = "011001";
                    break;
                case ":":
                    v = "011010";
                    break;
                case ";":
                    v = "011011";
                    break;
                case "-":
                    v = "011100";
                    break;
                case "=":
                    v = "011101";
                    break;
                case "&":
                    v = "011110";
                    break;
                case "?":
                    v = "011111";
                    break;
                case "@":
                    v = "100000";
                    break;
                case "A":
                    v = "100001";
                    break;
                case "B":
                    v = "100010";
                    break;
                case "C":
                    v = "100011";
                    break;
                case "D":
                    v = "100100";
                    break;
                case "E":
                    v = "100101";
                    break;
                case "F":
                    v = "100110";
                    break;
                case "G":
                    v = "100111";
                    break;
                case "H":
                    v = "101000";
                    break;
                case "I":
                    v = "101001";
                    break;
                case "J":
                    v = "101010";
                    break;
                case "K":
                    v = "101011";
                    break;
                case "L":
                    v = "101100";
                    break;
                case "M":
                    v = "101101";
                    break;
                case "N":
                    v = "101110";
                    break;
                case "O":
                    v = "101111";
                    break;
                case "P":
                    v = "110000";
                    break;
                case "Q":
                    v = "110001";
                    break;
                case "R":
                    v = "110010";
                    break;
                case "S":
                    v = "110011";
                    break;
                case "T":
                    v = "110100";
                    break;
                case "U":
                    v = "110101";
                    break;
                case "V":
                    v = "110110";
                    break;
                case "W":
                    v = "110111";
                    break;
                case "X":
                    v = "111000";
                    break;
                case "Y":
                    v = "111001";
                    break;
                case "Z":
                    v = "111010";
                    break;
            }
            return v;
        }
        #endregion
        /// <summary>
        /// 返回转换解码
        /// </summary>
        /// <param name="val"></param>
        /// <returns></returns>
        public string GetDecLTStr(string val)
        {
            string str = "";
            string v = "";
            for (int i = 0; i < val.Length; i++)
            {
                char c = val[i];
                v += GetDecHexadecimal(c.ToString());
            }
            for (int i = 0; i < v.Length; i++)
            {
                if (i % 6 == 0)
                {
                    string c = v.Substring(i, 6);
                    str += DecHexBinary(c);
                }
            }
            return str;
        }
        /// <summary>
        /// 2进制转换16进制
        /// </summary>
        /// <param name="s">4位的2进制</param>
        /// <returns></returns>
        private string GetDecHexadecimal(string s)
        {
            int bt = Convert.ToInt32(s, 16);
            string binaryNum = Convert.ToString(bt, 2);
            string result = string.Empty;
            //不足4位补0
            if (binaryNum.Length < 4)
            {
                int k = 4 - binaryNum.Length;
                for (int i = 0; i < k; i++)
                {
                    binaryNum = '0' + binaryNum;
                }
            }
            result += binaryNum;
            return result;
        }
        /// <summary>
        /// 2进制转换成正码
        /// </summary>
        /// <param name="str">单个字母</param>
        /// <returns></returns>
        private string DecHexBinary(string str)
        {
            string v = "";
            switch (str)
            {
                case "010000":
                    v = "0";
                    break;
                case "010001":
                    v = "1";
                    break;
                case "010010":
                    v = "2";
                    break;
                case "010011":
                    v = "3";
                    break;
                case "010100":
                    v = "4";
                    break;
                case "010101":
                    v = "5";
                    break;
                case "010110":
                    v = "6";
                    break;
                case "010111":
                    v = "7";
                    break;
                case "011000":
                    v = "8";
                    break;
                case "011001":
                    v = "9";
                    break;
                case "011010":
                    v = ":";
                    break;
                case "011011":
                    v = ";";
                    break;
                case "011100":
                    v = "-";
                    break;
                case "011101":
                    v = "=";
                    break;
                case "011110":
                    v = "&";
                    break;
                case "011111":
                    v = "?";
                    break;
                case "100000":
                    v = "@";
                    break;
                case "100001":
                    v = "A";
                    break;
                case "100010":
                    v = "B";
                    break;
                case "100011":
                    v = "C";
                    break;
                case "100100":
                    v = "D";
                    break;
                case "100101":
                    v = "E";
                    break;
                case "100110":
                    v = "F";
                    break;
                case "100111":
                    v = "G";
                    break;
                case "101000":
                    v = "H";
                    break;
                case "101001":
                    v = "I";
                    break;
                case "101010":
                    v = "J";
                    break;
                case "101011":
                    v = "K";
                    break;
                case "101100":
                    v = "L";
                    break;
                case "101101":
                    v = "M";
                    break;
                case "101110":
                    v = "N";
                    break;
                case "101111":
                    v = "O";
                    break;
                case "110000":
                    v = "P";
                    break;
                case "110001":
                    v = "Q";
                    break;
                case "110010":
                    v = "R";
                    break;
                case "110011":
                    v = "S";
                    break;
                case "110100":
                    v = "T";
                    break;
                case "110101":
                    v = "U";
                    break;
                case "110110":
                    v = "V";
                    break;
                case "110111":
                    v = "W";
                    break;
                case "111000":
                    v = "X";
                    break;
                case "111001":
                    v = "Y";
                    break;
                case "111010":
                    v = "Z";
                    break;
            }
            return v;
        }

        /// <summary>
        /// 从汉字转换到16进制
        /// </summary>
        /// <param name="s"></param>
        /// <returns></returns>
        public static string GetHexFromChs(string s)
        {
            if ((s.Length % 2) != 0)
            {
                s += " ";//空格
                         //throw new ArgumentException("s is not valid chinese string!");
            }

            System.Text.Encoding chs = System.Text.Encoding.GetEncoding("gb2312");

            byte[] bytes = chs.GetBytes(s);

            string str = "";

            for (int i = 0; i < bytes.Length; i++)
            {
                str += string.Format("{0:X}", bytes[i]);
            }

            return str;
        }
        /// <summary>
        /// 从16进制转换成汉字
        /// </summary>
        /// <param name="hex"></param>
        /// <returns></returns>
        public static string GetChsFromHex(string hex)
        {
            if (hex == null)
                throw new ArgumentNullException("hex");
            if (hex.Length % 2 != 0)
            {
                hex += "20";//空格
            }
            // 需要将 hex 转换成 byte 数组。
            byte[] bytes = new byte[hex.Length / 2];

            for (int i = 0; i < bytes.Length; i++)
            {
                try
                {
                    // 每两个字符是一个 byte。
                    bytes[i] = byte.Parse(hex.Substring(i * 2, 2),
                        System.Globalization.NumberStyles.HexNumber);
                }
                catch
                {
                    // Rethrow an exception with custom message.
                    throw new ArgumentException("hex is not a valid hex number!", "hex");
                }
            }

            // 获得 GB2312，Chinese Simplified。
            System.Text.Encoding chs = System.Text.Encoding.GetEncoding("gb2312");


            return chs.GetString(bytes);
        }
    }
}
